summaryrefslogtreecommitdiffstats
path: root/system/gitolite
diff options
context:
space:
mode:
author Mario Preksavec <mario at slackware dot hr>2015-02-12 00:17:10 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2015-02-12 00:17:10 +0700
commitffaf60b234e0568f46b09cd8acf79eed7368a58e (patch)
tree488caa85cd3082eef59b01c2ddef34f6a792940a /system/gitolite
parent7ded051ce66a78257002d9ea15aabd3b6fff9129 (diff)
downloadslackbuilds-ffaf60b234e0568f46b09cd8acf79eed7368a58e.tar.gz
slackbuilds-ffaf60b234e0568f46b09cd8acf79eed7368a58e.tar.xz
system/gitolite: Added (Hosting git repositories).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'system/gitolite')
-rw-r--r--system/gitolite/README13
-rw-r--r--system/gitolite/README.SLACKWARE11
-rw-r--r--system/gitolite/gitolite9
-rw-r--r--system/gitolite/gitolite.SlackBuild103
-rw-r--r--system/gitolite/gitolite.info10
-rw-r--r--system/gitolite/slack-desc19
6 files changed, 165 insertions, 0 deletions
diff --git a/system/gitolite/README b/system/gitolite/README
new file mode 100644
index 0000000000..7b689ef7ac
--- /dev/null
+++ b/system/gitolite/README
@@ -0,0 +1,13 @@
+gitolite (Hosting git repositories)
+
+Gitolite allows you to setup git hosting on a central server, with very
+fine-grained access control and many (many!) more powerful features.
+
+This script expects and offers commands to create 'gitolite' user and a
+group. Switching to a more popular username, such as 'git', is done by
+running the script like this:
+
+ GL_USER=git GL_GROUP=git ./gitolite.SlackBuild
+
+See README.SLACKWARE (which is also installed with the package docs) for
+setup, configuration, and usage hints.
diff --git a/system/gitolite/README.SLACKWARE b/system/gitolite/README.SLACKWARE
new file mode 100644
index 0000000000..25e949b205
--- /dev/null
+++ b/system/gitolite/README.SLACKWARE
@@ -0,0 +1,11 @@
+For the first-time setup, you need to have a public key file installed
+on the gitolite server. This can be done by issuing the following command:
+
+ gitolite setup -pk /path/to/YourName.pub
+
+If this command completes without any warnings, you are done. Otherwise,
+you probably supplied a key file which already has shell access to the
+server. That won't work; you'll have to generate and use a different key pair
+for gitolite access and use host aliases to distinguish between the two. The
+'setup' command has other uses, more information is available in the README
+file installed with the package docs.
diff --git a/system/gitolite/gitolite b/system/gitolite/gitolite
new file mode 100644
index 0000000000..af1c0bb5ab
--- /dev/null
+++ b/system/gitolite/gitolite
@@ -0,0 +1,9 @@
+#!/bin/bash
+
+GL_USER=@GL_USER@
+
+if [ "$(whoami)" == "$GL_USER" ]; then
+ /usr/libexec/gitolite/gitolite ${@}
+else
+ su -c "/usr/libexec/gitolite/gitolite ${@}" $GL_USER
+fi
diff --git a/system/gitolite/gitolite.SlackBuild b/system/gitolite/gitolite.SlackBuild
new file mode 100644
index 0000000000..47a977f4ab
--- /dev/null
+++ b/system/gitolite/gitolite.SlackBuild
@@ -0,0 +1,103 @@
+#!/bin/sh
+
+# Slackware build script for gitolite
+
+# Copyright 2015 Mario Preksavec, Zagreb, HR
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=gitolite
+VERSION=${VERSION:-3.6.2}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+ARCH=noarch
+
+GL_USER=${GL_USER:-gitolite}
+GL_GROUP=${GL_GROUP:-gitolite}
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+# Bail if user or group isn't valid on your system
+if ! grep ^$GL_USER: /etc/passwd 2>&1 > /dev/null; then
+
+cat << EOF
+
+ You must have $GL_USER user and $GL_USER group to run this script
+
+ # groupadd -g 301 $GL_GROUP
+ # useradd -u 301 -d /var/lib/gitolite -s /bin/bash -g $GL_GROUP $GL_USER
+
+ Key-based authentication can be enabled with
+
+ # usermod -p '*' $GL_USER
+
+EOF
+
+ exit
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/v$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+# Get vendor lib dir
+PERL_VENDOR_LIB=$(perl -MConfig -le 'print substr($Config{installvendorlib}, 1)')
+
+# Make dirs manually
+mkdir -p $PKG/usr/libexec $PKG/$PERL_VENDOR_LIB
+mkdir -p -m 750 $PKG/var/lib/gitolite
+chown $GL_USER:$GL_GROUP $PKG/var/lib/gitolite
+
+# Copy everything
+cp -a src $PKG/usr/libexec/gitolite
+
+# Move libs to vendor lib dir
+mv $PKG/usr/libexec/gitolite/lib/Gitolite $PKG/$PERL_VENDOR_LIB
+
+# Delete cruft left behind
+rmdir $PKG/usr/libexec/gitolite/lib
+
+# Install a little wrapper script
+install -D -m0755 -oroot -groot $CWD/gitolite $PKG/usr/bin/gitolite
+sed -i "s/@GL_USER@/$GL_USER/" $PKG/usr/bin/gitolite
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a CHANGELOG CONTRIBUTING COPYING README.markdown $CWD/README.SLACKWARE \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/system/gitolite/gitolite.info b/system/gitolite/gitolite.info
new file mode 100644
index 0000000000..4147015390
--- /dev/null
+++ b/system/gitolite/gitolite.info
@@ -0,0 +1,10 @@
+PRGNAM="gitolite"
+VERSION="3.6.2"
+HOMEPAGE="http://gitolite.com/"
+DOWNLOAD="https://github.com/sitaramc/gitolite/archive/v3.6.2.tar.gz"
+MD5SUM="72b70ed378a775b5cd496ee02b81c467"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Mario Preksavec"
+EMAIL="mario at slackware dot hr"
diff --git a/system/gitolite/slack-desc b/system/gitolite/slack-desc
new file mode 100644
index 0000000000..c90cef519b
--- /dev/null
+++ b/system/gitolite/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+gitolite: gitolite (Hosting git repositories)
+gitolite:
+gitolite: Gitolite allows you to setup git hosting on a central server, with
+gitolite: very fine-grained access control and many (many!) more powerful
+gitolite: features.
+gitolite:
+gitolite: Homepage: http://gitolite.com/
+gitolite:
+gitolite:
+gitolite:
+gitolite: